// ConsoleAppTemplate.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <windows.h>
//#include <stdio.h>
//#include <winbase.h>
#include <conio.h>
////#include "cmdline.h"
//#include <stdlib.h>
////#include <shlwapi.h>
////#include <mmsystem.h>
//
#include "support.h"
#include "usbi2cio.h"

int _tmain(int argc, _TCHAR* argv[]) {

	BYTE byBoards;
	HANDLE hDevInstance = INVALID_HANDLE_VALUE;     // device instance handle
	char sDevSerialId[9] = "";


	// display the application version information
    system("cls");        // clear the console screen
	printf("\nDeVaSys USB-I2C/IO Console Application Template 1.00\n");
	printf("Copyright DeVaSys 2009\n\n");

	if( !CheckDllAndDrvVersions(0x0304, 0x0300) ) {
		// the user's P.C. is not running appropriate versions of driver and dll
		printf("CRITICAL ERROR - System is not running a supported version of driver or dll\n");
		printf("No further operations are possible, exiting\n");
		printf("Press any key to continue\n");
		while (!kbhit());
		return FALSE;
	}

	byBoards = DAPI_GetDeviceCount( "UsbI2cIo" );

	if(byBoards == 0) {
		printf("CRITICAL ERROR - No USB-I2C/IO boards detected, exiting\n");
		printf("Press any key to continue\n");
		while (!kbhit());
		return 0;
	}
	else if(byBoards > 1) {
		printf("WARNING - Multiple USB-I2C/IO boards detected, using instance zero\n");
	}

	hDevInstance = DAPI_OpenDeviceInstance("UsbI2cIo", 0);
	if(hDevInstance == INVALID_HANDLE_VALUE) {
		// we were unable to open a handle to the USB-I2C/IO board
		printf("CRITICAL ERROR - Unable to open a handle to the USB-I2C/IO board\n");
		printf("Without a valid device handle, no further operations are possible, exiting\n");
		printf("Press any key to continue\n");
		while (!kbhit());
		return FALSE;
	}

	if( !CheckBoardFirmwareVersion(&hDevInstance, 0x0300, 0x0999) ) {
		printf("CRITICAL ERROR - Board is not running a supported version of firmware\n");
		printf("No further operations are possible, exiting\n");
		printf("Press any key to continue\n");
		while (!kbhit());
		return FALSE;
    }

	if( !DAPI_GetSerialId(hDevInstance, sDevSerialId) ) {
		// we were unable to fetch a serial number from the USB-I2C/IO board
		printf("CRITICAL ERROR - Unable to fetch a Serial ID from the USB-I2C/IO board\n");
		printf("Without a valid serial number, no further operations are possible, exiting\n");
		printf("Press any key to continue\n");
		while (!kbhit());
		return FALSE;
	}
	else {
		printf(" Board SerialId   = \"%s\"\n", sDevSerialId);
	}
	// if we make it to here, dll, driver, and firmware versions are all ok, and we have an open handle to a board.
  
	// close the handle
	DAPI_CloseDeviceInstance(hDevInstance);

	printf("\nPress any key to continue\n");
	while (!kbhit());
	return 1;
}

