// support.cpp : This module contains common support routines
//

#include "stdafx.h"

//if( !CheckDllAndDrvVersions(0x0304, 0x0300) ) {
//    // the user's P.C. is not running appropriate versions of driver and dll
//    return FALSE;
//  }

BOOL CheckDllAndDrvVersions(WORD wMinDllVersion, WORD wMinDrvVersion) {

  BOOL bRetVal = TRUE;

  WORD wVersion;
	BYTE byVerHigh;
  BYTE byVerLow;


  // fetch the dll version and test it
	// WORD _stdcall DAPI_GetDllVersion(void);
	wVersion = DAPI_GetDllVersion();
  byVerHigh = HIBYTE(wVersion);
  byVerLow = LOBYTE(wVersion);
//	printf(" DLL Version      = %d.%d\n", byVerHigh, byVerLow);
	printf(" DLL Version      = %X.%02X\n", byVerHigh, byVerLow);

  if( wVersion >= wMinDllVersion ) {

    // dll is ok, now fetch the driver version and test it
  	wVersion = DAPI_GetDriverVersion();
    byVerHigh = HIBYTE(wVersion);
    byVerLow = LOBYTE(wVersion);
//  	printf(" DRIVER Version   = %d.%d\n", byVerHigh, byVerLow);
  	printf(" DRIVER Version   = %X.%02X\n", byVerHigh, byVerLow);

  if( !(wVersion >= wMinDrvVersion) ) {
      // warn about drv version and return false
//  	  printf(" ERROR - This application requires Driver Version %d.%d (or newer)\n",
  	  printf(" ERROR - This application requires Driver Version %X.%02X (or newer)\n",
        HIBYTE(wMinDrvVersion), LOBYTE(wMinDrvVersion));
//  	  printf(" Wanted: %d.%d\n", byDrvVerHigh, byDrvVerLow);
//  	  printf("    Got: %d.%d\n", byVerHigh, byVerLow);
      bRetVal = FALSE;
    }
  }
  else {
    // warn about dll version and return false
//  	  printf(" ERROR - This application requires UsbI2cIo.dll Version 3.4 (or newer)\n");
// 	  printf(" ERROR - This application requires UsbI2cIo.dll Version %d.%d (or newer)\n",
 	  printf(" ERROR - This application requires UsbI2cIo.dll Version %X.%02X (or newer)\n",
        HIBYTE(wMinDllVersion), LOBYTE(wMinDllVersion));
    bRetVal = FALSE;
  }

  return bRetVal;
}

BOOL CheckBoardFirmwareVersion(HANDLE * phDevInstance, WORD wMinVersion, WORD wMaxVersion) {

  BOOL bRetVal = TRUE;

  WORD wVersion;

  // fetch the firmware version and test it
  // BOOL _stdcall DAPI_GetFirmwareVersion(HANDLE hDevInstance, LPWORD lpwVersion);
	// WORD _stdcall DAPI_GetDllVersion(void);
  if(!DAPI_GetFirmwareVersion(*phDevInstance, &wVersion) ) {
		// we were unable to fetch the firmware version from the USB-I2C/IO board
		printf("CRITICAL ERROR - Unable to get the firmware version of the USB-I2C/IO board\n");
    printf("Without the firmware version, no further operations are possible, exiting\n");
    printf("Press any key to continue\n");
		while (!kbhit());
    return FALSE;
  }

//	printf(" Firmware Version = %d.%d\n", HIBYTE(wVersion), LOBYTE(wVersion));
	printf(" Firmware Version = %X.%02X\n", HIBYTE(wVersion), LOBYTE(wVersion));

  if( (wVersion >= wMinVersion) && (wVersion <= wMaxVersion) ) {
  }
  else {
    // warn about firmware version and return false
    if(wMinVersion == wMaxVersion) {
//   	  printf(" ERROR - expected Firmware Version %d.%d\n",
   	  printf(" ERROR - expected Firmware Version %X.%02X\n",
          HIBYTE(wMinVersion), LOBYTE(wMinVersion));
    }
    else {
//   	  printf(" ERROR - expected Firmware Versions %d.%d through %d.%d\n",
   	  printf(" ERROR - expected Firmware Versions %d.%d through %X.%02X\n",
          HIBYTE(wMinVersion), LOBYTE(wMinVersion),
          HIBYTE(wMaxVersion), LOBYTE(wMaxVersion));
    }
    bRetVal = FALSE;
  }

  return bRetVal;
}

